import abc
from _typeshed import Incomplete
from decimal import Decimal
from dojo.agents.base_agent import BaseAgent as BaseAgent
from dojo.observations import UniswapV3Observation as UniswapV3Observation
from typing import Any

class UniswapV3Agent(BaseAgent[UniswapV3Observation], metaclass=abc.ABCMeta):
    unit_token: Incomplete
    initial_wealth: Incomplete
    def __init__(self, initial_portfolio: dict[str, Decimal], unit_token: str, policy: Any, name: str | None = None) -> None: ...
    def get_liquidity_ownership_tokens(self) -> list[int]: ...
    def total_wealth(self, obs: UniswapV3Observation, unit_token: str) -> float: ...
    def get_pnl(self, obs: UniswapV3Observation) -> float: ...
    def get_total_current_wealth(self, obs: UniswapV3Observation) -> float: ...
    def get_hodling_difference(self, obs: UniswapV3Observation) -> float: ...

class TotalWealthAgent(UniswapV3Agent):
    def __init__(self, initial_portfolio: dict[str, Decimal], unit_token: str, policy: Any, name: str | None = None) -> None: ...
    def reward(self, obs: UniswapV3Observation) -> float: ...

class PnLAgent(UniswapV3Agent):
    def __init__(self, initial_portfolio: dict[str, Decimal], unit_token: str, policy: Any, name: str | None = None) -> None: ...
    def reward(self, obs: UniswapV3Observation) -> float: ...

class HodlComparisonAgent(UniswapV3Agent):
    def __init__(self, initial_portfolio: dict[str, Decimal], unit_token: str, policy: Any, name: str | None = None) -> None: ...
    def reward(self, obs: UniswapV3Observation) -> float: ...
